// ============================================================================
// Copyright Jean-Charles LAMBERT - 2008-2015
//           Centre de donneeS Astrophysiques de Marseille (CeSAM)
// e-mail:   Jean-Charles.Lambert@lam.fr
// address:  Dynamique des galaxies
//           Laboratoire d'Astrophysique de Marseille
//           Pole de l'Etoile, site de Chateau-Gombert
//           38, rue Frederic Joliot-Curie
//           13388 Marseille cedex 13 France
//           CNRS U.M.R 6110
// ============================================================================

/**
  @author Jean-Charles Lambert <Jean-Charles.Lambert@lam.fr>
 */
#ifndef SNAPSHOTRAMSES_H
#define SNAPSHOTRAMSES_H

#include "snapshotinterface.h"
//#include "camr.h"
//#include "cpart.h"

namespace ramses {
class CAmr;
class CPart;
}
namespace uns {

class CParticles {
public:
  CParticles() {    
    ntot  =0; // SWIG forbid multiple variable affectation
    ngas  =0; // like ntto=ngas=ndm=0 !!!!!!!!!
    ndm   =0; // it was a bug in py_unsio wrapper for ramses files,
    nstars=0; // really really damn crazy !!!!!

    load_bits=0;
  }
  std::vector <float> pos,vel,mass,hsml,rho,temp,age,metal;
  std::vector <int> indexes,id;
  int ntot, ngas, ndm, nstars;
  unsigned int load_bits;
};

class CSnapshotRamsesIn: public CSnapshotInterfaceIn {

public:
  CSnapshotRamsesIn(const std::string, const std::string, const std::string, const bool verb=false);

  ~CSnapshotRamsesIn();
  // pure virtual function implemented
  ComponentRangeVector * getSnapshotRange();
  int nextFrame(uns::UserSelection &);
  bool getData(const std::string,int *n,float **);
  bool getData(const std::string,       float * );
  bool getData(const std::string,int *n,int   **);
  bool getData(const std::string,       int   * );
  bool getData(const std::string, const std::string ,int *,float **);
  bool getData(const std::string, const std::string ,int *,int   **);
 int close();

private:
 ramses::CAmr * amr;
 ramses::CPart * part;
 CParticles * particles;
 bool first_loc;

 int reorderParticles(uns::UserSelection & );
};
}
#endif // SNAPSHOTRAMSES_H

